/*
 *       This Code Was Created By Jan Koci 2002
 *       Visit My Site At http://koci.opengl.cz
 */

//---------------------------------------------------------------------------

     // Unita pro vykreslovani objektu

//---------------------------------------------------------------------------

#include <vcl\vcl.h>
#pragma hdrstop

#include "gl/gl.h"    //pouzivej hlavickovy soubor pro ovladac OpenGL32.dll
#include "gl/glu.h"    //pouzivej hlavickovy soubor pro ovladac GLu32.dll
#include "KDrawObjects.h"    //pouzivej hlavickovy soubor teto unity
#include "KTextures.h"    //pouzivej hlavickovy soubor pro generovan 1D textur, nebo nacitani 2D textur
#include "KRenderForm.h"    //pouzivej hlavickovy soubor formulare na kterem bezi rendering
#include "KTypes.h"    //pouzivej hlavickovy soubor datovych struktur
#include "KTime.h"    //pouzivej hlavickovy soubor pro vypocet fps a plynule animace
//---------------------------------------------------------------------------

//definice promennych
extern GLuint Texture[1];    //2d textura, pole s jednou texturou
extern TGLObject cube1;    //objekt krychle
extern float step;    //promenna pomoci ktere plynule beha animace
TPoint3d angle;    //uhel rotace objektu
TPoint3d translate;    //pozice objektu
TPoint3d direction;    //smer pohybu objektu
bool start=true;    //pomocna promenna pro nacitani zakladnich hodnot pri startu aplikace


//---------------------------------------------------------------------------

void TranRotCube()    //vypocitej pohyb a rotaci
{
    //zacatek vypoctu pohybu objektu
    if (start)    //jestlize probiha prvni otocka cyklu
    {
      direction.x = 1;    //nastav smer pohybu objektu v X smeru na 1
      direction.y = 1;    //nastav smer pohybu objektu v Y smeru na 1
      direction.z = 1;    //nastav smer pohybu objektu v Z smeru na 1
      translate.z = -8;   //nastav Z pozici objektu
      start = false;    //nastav start na false, aby pri dalsi otocce cyklu se zakladni hodnoty nenacitaly
    }
    //ShowMessage("step" + FloatToStr(step));
    if ((translate.x >= 3) || (translate.x <= -3))  //jetlize X pozice objektu presahne hodnoty 3 nebo -3
    {
        direction.x = -direction.x;    //otoc smer pohybu X
    }
    translate.x = translate.x + (0.01 * direction.x * (step));    //pricti 0.01 pozici X, podle smeru pohybu X a velikosti kroku

    if ((translate.y >= 2) || (translate.y <= -2))    //jetlize Y pozice objektu presahne hodnoty 2 nebo -2
    {
        direction.y = -direction.y;    //otoc smer pohybu Y
    }
    translate.y = translate.y + (0.01 * direction.y * (step));    //pricti 0.01 pozici Y, podle smeru pohybu Y a velikosti kroku

    if ((translate.z >= -6) || (translate.z <= -20))    //jetlize Z pozice objektu presahne hodnoty -6 nebo -20
    {
        direction.z = -direction.z;    //otoc smer pohybu Z
    }
    translate.z = translate.z + (0.01 * direction.z * (step));    //pricti 0.01 pozici Z, podle smeru pohybu Z a velikosti kroku
    //konec vypoctu pohybu objektu

    //zacatek vypoctu rotace objektu
    angle.x = angle.x + (0.5 * (step));    //pricti 0.5 uhlu X rotace podle velikosti kroku
    if (angle.x >= 360)    //jestlize je uhel vetsi, nez 360 stupnu
    {
      angle.x = angle.x -360;    //odecti 360 stupnu
    }

    angle.y = angle.y + (1 * (step));    //pricti 1 uhlu Y rotace podle velikosti kroku
    if (angle.y >= 360)    //jestlize je uhel vetsi, nez 360 stupnu
    {
      angle.y = angle.y -360;    //odecti 360 stupnu
    }

    angle.z = angle.z + (1.5 * (step));    //pricti 1.5 uhlu Z rotace podle velikosti kroku
    if (angle.z >= 360)    //jestlize je uhel vetsi, nez 360 stupnu
    {
      angle.z = angle.z -360;    //odecti 360 stupnu
    }
    //konec vypoctu rotace objektu
}

//---------------------------------------------------------------------------

GLvoid DrawCube(GLvoid)    //vykresli krychli
{
    TranRotCube();    //vypocitej pohyb a rotaci krychle

    //zacatek bloku OpenGL prikazu pro vykresleni objektu (krychle)
    glEnable(GL_TEXTURE_2D);    //zapni 2D texturovani
    glBindTexture(GL_TEXTURE_2D, Texture[0]);    //potahni nasledujici objekt texturou cislo 0
    glPushMatrix;    //zacatek prostorove matice

    //posouvej a rotuj objektem (ktery je mezi glPushMatrix; a glPopMatrix;) podle vypoctenych hodnot
    glTranslatef( translate.x, translate.y, translate.z);    //pohni celym objektem
    glRotatef( angle.x, 1, 0, 0);    //rotuj objektem v X smeru
    glRotatef( angle.y, 0, 1, 0);    //rotuj objektem v Y smeru
    glRotatef( angle.z, 0, 0, 1);    //rotuj objektem v Z smeru

    glBegin(GL_TRIANGLES);    //zacni vykreslovat trojuhelniky
      //------------------------

      //predni stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[0].x, cube1.points[0].y, cube1.points[0].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[1].x, cube1.points[1].y, cube1.points[1].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[2].x, cube1.points[2].y, cube1.points[2].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[3].x, cube1.points[3].y, cube1.points[3].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[2].x, cube1.points[2].y, cube1.points[2].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[1].x, cube1.points[1].y, cube1.points[1].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------

      //prava stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[2].x, cube1.points[2].y, cube1.points[2].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[3].x, cube1.points[3].y, cube1.points[3].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[4].x, cube1.points[4].y, cube1.points[4].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[5].x, cube1.points[5].y, cube1.points[5].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[4].x, cube1.points[4].y, cube1.points[4].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[3].x, cube1.points[3].y, cube1.points[3].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------

      //zadni stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[4].x, cube1.points[4].y, cube1.points[4].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[5].x, cube1.points[5].y, cube1.points[5].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[6].x, cube1.points[6].y, cube1.points[6].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[7].x, cube1.points[7].y, cube1.points[7].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[6].x, cube1.points[6].y, cube1.points[6].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[5].x, cube1.points[5].y, cube1.points[5].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------

      //leva stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[6].x, cube1.points[6].y, cube1.points[6].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[7].x, cube1.points[7].y, cube1.points[7].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[0].x, cube1.points[0].y, cube1.points[0].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[1].x, cube1.points[1].y, cube1.points[1].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[0].x, cube1.points[0].y, cube1.points[0].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[7].x, cube1.points[7].y, cube1.points[7].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------

      //vrchni stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[1].x, cube1.points[1].y, cube1.points[1].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[7].x, cube1.points[7].y, cube1.points[7].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[3].x, cube1.points[3].y, cube1.points[3].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[5].x, cube1.points[5].y, cube1.points[5].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[3].x, cube1.points[3].y, cube1.points[3].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[7].x, cube1.points[7].y, cube1.points[7].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------

      //spodni stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[6].x, cube1.points[6].y, cube1.points[6].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[0].x, cube1.points[0].y, cube1.points[0].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[4].x, cube1.points[4].y, cube1.points[4].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[2].x, cube1.points[2].y, cube1.points[2].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[4].x, cube1.points[4].y, cube1.points[4].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[0].x, cube1.points[0].y, cube1.points[0].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------


    glEnd();  //ukonci vykreslovani trojuhelniku
    glPopMatrix;    //konec prostorove matice
    //konec bloku OpenGL prikazu pro vykresleni objektu (krychle)
}

//---------------------------------------------------------------------------








//---------------------------------------------------------------------------


#pragma package(smart_init)
