/*
 *       This Code Was Created By Jan Koci 2002
 *       Visit My Site At http://koci.opengl.cz
 */

//---------------------------------------------------------------------------

    // Unita, ktera nastavi zakladni hodnoty OpenGL a vystup vykresluje na fomular

//---------------------------------------------------------------------------

#include <vcl\vcl.h>
#pragma hdrstop
#include <float.h>    //nacteni knihovny pro deleni cisel s plovouci carkou

#include "gl/gl.h"    //pouzivej hlavickovy soubor pro ovladac OpenGL32.dll
#include "gl/glu.h"    //pouzivej hlavickovy soubor pro ovladac GLu32.dll
#include "KRenderForm.h"    //pouzivej hlavickovy soubor teto unity
#include "KDrawObjects.h"    //pouzivej hlavickovy soubor pro vykreslovani objektu
#include "KThread.h"    //pouzivej hlavickovy soubor pro nastaveni vlakna na rendering sceny
#include "KTextures.h"    //pouzivej hlavickovy soubor pro generovan 1D textur, nebo nacitani 2D textur
#include "KLoadObjects.h"    //pouzivej hlavickovy soubor pro nacitani objektu z textovych a binarnich souboru
#include "KTime.h"    //pouzivej hlavickovy soubor pro mereni fps a vypoctu plynule animace podle fps 

//---------------------------------------------------------------------------

#pragma resource "*.dfm"
TForm1 *Form1;    //definice promenne Form1

//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
   TMyThread *RenderThread = new TMyThread(true);    //vytvor renderovaci vlakno
   RenderThread->Run();   //rozjed renderovaci vlakno

    _control87(MCW_EM, MCW_EM);    //zamezeni deleni nulou
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Loop()
{
    wglMakeCurrent(m_hDC, m_hRC);    //pripoj m_hRC (OpenGL Rendering Context) do m_hDC (Windows Device Context), ktery komunikuje s wokenim GDI (Graphics Device Interface)
    glClear(GL_COLOR_BUFFER_BIT);    //vycisti buffer barev
    glClear(GL_DEPTH_BUFFER_BIT);    //vycisti hloubkovy(DEPTH) buffer
    glLoadIdentity();    //resetuj soucasnou modelovou matici
    RenderGLScene();    //vykresli OpenGl scenu
    SwapBuffers(m_hDC);    //prohod buffery (double burrefing)
    wglMakeCurrent(m_hDC, NULL);    //vynuluj m_hRC (OpenGL Rendering Context)
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    SetWindowStats(640, 480, 16);    //nastav rozliseni 640*480 16 bitova hloubka barev

    m_hDC = GetDC(Handle);    //nacti handle okna do m_hDC (Windows Device Context)
    SetPixelFormatDescriptor();    //nastav format vystupniho pixelu
    m_hRC = wglCreateContext(m_hDC);    //vytvor m_hRC (OpenGL Rendering Context)
    wglMakeCurrent(m_hDC, m_hRC);     //pripoj m_hRC (OpenGL Rendering Context) do m_hDC (Windows Device Context), ktery komunikuje s wokenim GDI (Graphics Device Interface)

    FormResize(NULL);    //vycisti okno pred iniciaci OpenGL

    InitGL();    //inicializuj OpenGL
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
    wglMakeCurrent(m_hDC, m_hRC);    //pripoj m_hRC (OpenGL Rendering Context) do m_hDC (Windows Device Context), ktery komunikuje s wokenim GDI (Graphics Device Interface)

    glViewport(0, 0, ClientWidth, ClientHeight);    //nastav velikost zobrazovaci plochy
    glMatrixMode(GL_PROJECTION);    //nastav matici zobrazeni prostoru
    glLoadIdentity();    //pouzij tuto matici

    //vypocti velikost zobrazovaci plochy. Nastav uhel pohledu kamery, nejblizsi a nejvzdalenejsi viditelny bod
    gluPerspective(45.0, static_cast<double>(ClientWidth) / static_cast<double>(ClientHeight),0.1,100.0);

    glMatrixMode(GL_MODELVIEW);    //nastav matici zobrazeni objektu
    glLoadIdentity();    //pouzij tuto matici

    wglMakeCurrent(m_hDC, NULL);    //vynuluj m_hRC (OpenGL Rendering Context)
}

//---------------------------------------------------------------------------

void __fastcall TForm1::SetPixelFormatDescriptor()
{
    PIXELFORMATDESCRIPTOR pfd = {    //rekni woknum jak maj zobrazit obrazovkovy pixel
      sizeof(PIXELFORMATDESCRIPTOR),    //velikost descriptoru
      1,    //cislo verze
      PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,    //formaty podporujici wokna, OpenGL, nastaveni doublebufferu
      PFD_TYPE_RGBA,    //pouzivej barvy ve formatu RGBA
      24,    //buffer barev
      0,0,0,0,0,0,
      0,0,
      0,0,0,0,0,
      32,    //32Bit Z-Buffer (Depth buffer)
      0,    // Stencil buffer
      0,
      PFD_MAIN_PLANE,    //vykreslovaci vrstva
      0,
      0,0,0
      };
    m_iPixelFormat = ChoosePixelFormat(m_hDC, &pfd);    //vyber nejvhodnejsi pixelovy format
    SetPixelFormat(m_hDC, m_iPixelFormat, &pfd);    //a tento pixelovy format nastav
}

//---------------------------------------------------------------------------

bool __fastcall TForm1::SetWindowStats(int iWidth_, int iHeight_, int iColor_)
{
    ClientWidth = iWidth_;    //precti sirku okna
    ClientHeight = iHeight_;    //precti vysku okna

    // zeptej se, jestli budu chtit okno prepnout do fullscreenu
    if(Application->MessageBox("Would You Like To Run In Fullscreen Mode?",
                               "Start FullScreen?",
                               MB_YESNO|MB_ICONQUESTION)==IDYES)
    {
      //pokud zadam Ano nastav tyto hodnoty
      DEVMODE dmScreenSettings;    // Device Mode - mod zarizeni
      memset(&dmScreenSettings,0,sizeof(dmScreenSettings));    //vycisti pamet
      dmScreenSettings.dmSize=sizeof(dmScreenSettings);    //velikost struktury
      dmScreenSettings.dmPelsWidth = iWidth_;    //nastav sirku obrazovky
      dmScreenSettings.dmPelsHeight = iHeight_;    //nastav vysku obrazovky
      dmScreenSettings.dmBitsPerPel = iColor_;    //nastav hloubku barev
      dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

        //pokud jsou nektere parametry spatne nastaveny
        if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		  {
        return false;    //tak opust funkci
		  }
      else    //jinak prepni na fullscreen a
      {
        BorderStyle = bsNone;    //nastav okno, aby bylo bez ramecku a tlacitek
        Left = 0;    //nastav levy okraj okna na 0
        Top = 0;    //nastav horni okraj okna na 0
        ShowCursor(FALSE);    //schovej kurzor mysi
      }
    }

    return true;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormKeyPress(TObject *Sender, char &Key)
{
    if(Key == VK_ESCAPE)    //jestlize klepnu na klavesu Esc
    Close();    //ukonci aplikaci
}

//---------------------------------------------------------------------------

bool __fastcall TForm1::InitGL()
{
  wglMakeCurrent(m_hDC, m_hRC);    //pripoj m_hRC (OpenGL Rendering Context) do m_hDC (Windows Device Context), ktery komunikuje s wokenim GDI (Graphics Device Interface)
  glClearColor(0.0f, 0.0f, 0.0f, 0.5f);    //nastav cerne pozadi sceny
    ////sem budu zadavat funkce, ktere se maji provadet jen pri startu aplikace////
      glEnable(GL_DEPTH_TEST);    //zapni hloubkovy (DEPTH) buffer, aby objekty bliz ke kamere prekryvali vzdalenejsi
      LoadGLTextures();    //vytvor textury
      LoadAllObjects();    //nacti objekty
    ////konec zadavani funkci, ktere se maji provadet jen pri startu aplikace////
  wglMakeCurrent(m_hDC, NULL);    //vynuluj m_hRC (OpenGL Rendering Context)
	return TRUE;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::RenderGLScene()
{
    DrawCube();    //vykresli krychli
    CalcFPS();    //vypocitej fps
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{

    if(BorderStyle == bsNone)    //pokud je fullscreen
    ChangeDisplaySettings(NULL,0);    //nastav puvodni hodnotu rozliseni obrazovky

    ReleaseDC(Handle, m_hDC);    //uvolni handle okna m_hDC (Windows Device Context)
    wglMakeCurrent(m_hDC, NULL);    //vynuluj m_hRC (OpenGL Rendering Context)
    wglDeleteContext(m_hRC);    //vymaz m_hRC (OpenGL Rendering Context)
    RenderThread->Done();    //ukonci renderovaci vlakno

    DeleteAllObjects();    //vymaz objekty z pameti
}
//---------------------------------------------------------------------------
